(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question07 - test        *)

module Q = Question07

let rec make_tree q = function
  | 0 -> Q.Empty
  | n ->
      Q.Node(make_tree q (n-1), q#getN, make_tree q (n-1))

let rec print_tree = function
  | Q.Empty -> Format.printf "Empty"
  | Q.Node(Q.Empty,k,Q.Empty) ->
      Format.printf "@,@[<h>Node(Empty,%02d,Empty)@]" k
  | Q.Node(fg,k,fd) ->
      Format.printf "@,@[<v 2>Node(";
      print_tree fg;
      Format.printf ",@;%02d," k;
      print_tree fd;
      Format.printf "@,)@]"

let print x =
  Format.printf " %02d;" x

let sep () =
  Format.printf "@,"

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 7 100 in
      q#beginParse;
      q#init;
      let t = make_tree q q#getSize in
	Format.printf "@[<v 2>t =";
	print_tree t;
	Format.printf "@]@.@.";
	Format.printf "@[<v 2>bf print sep =@,";
	Q.bf print sep t;
	Format.printf "@]@.";
	exit 0
  end

let _ = main ()
