exception Queue_empty

module type OrderedType =
sig
  type t
  val compare : t -> t -> int
end

module type S =
  sig
    type elt
    type t
    val empty : unit -> t
    val is_empty : t -> bool
    val size : t -> int
    val push : elt -> t -> unit
    val pop : t -> elt
  end
module PriorityQueue :
  functor (T : OrderedType) -> S with type elt = T.t
