(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question02 - test        *)

module Q = Question02

let rec exp x = function
  | 0 -> 1
  | 1 -> x
  | n ->
      exp (x*x) (n/2) * (if n mod 2 = 0 then 1 else x)

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 2 10 in
      q#beginParse;
      q#init;
      for i = 1 to q#getSize do
	let x = q#getN in
	let n = exp 2 x in
	let m = exp 3 x in
	  Format.printf "intlog 2 %d\t= %d\t(should be %d)@."
	    n (Q.intlog 2 n) x;
	  Format.printf "intlog 3 %d\t= %d\t(should be %d)@.@."
	    m (Q.intlog 3 m) x;
      done;
      exit 0;
  end

let _ = main ()
