(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question05 - test        *)

module Q = Question05

let rec pp f = function
  | Q.Empty -> Format.printf "]@]@;"
  | Q.Cons (h,t) ->
      Format.printf "%s;@;" (f h);
      pp f t
  | Q.Concat (l1,l2) ->
      Format.printf "@[<b 2>[@,";
      pp f l1;
      Format.printf "@@ @[<b 2>[@,";
      pp f l2;
      Format.printf "]@]@;"

let rec build q = function
  | 0 -> Q.Empty
  | n -> Q.add q#getN (build q (n-1))

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 5 32 in
      q#beginParse;
      q#init;
      let l1 = build q q#getSize in
      let l2 = build q q#getSize in
	begin
	  Format.printf "@[<b>l1 =@;@[<b 2>[@;";
	  pp Test_frame.i2s l1;
	  Format.printf "@.@[<b>l2 =@;@[<b 2>[@;";
	  pp Test_frame.i2s l2;
	  Format.printf "@.";
	  let l = Q.append l1 l2 in
	  let l' = Q.append l l in
	    Format.printf "@[<b 2>l = append l1 l2 =@;@[<b 2>[@;";
	    pp Test_frame.i2s l;
	    Format.printf "@.";
	    Format.printf "@[<b 2>l' = append l l =@;@[<b 2>[@;";
	    pp Test_frame.i2s l';
	    Format.printf "@.";
	    Format.printf "len l1 = %d@." (Q.len l1);
	    Format.printf "len l2 = %d@." (Q.len l2);
	    Format.printf "len l = %d@." (Q.len l);
	    Format.printf "len l' = %d@.@." (Q.len l');
	    Format.printf "f x = x * 2@.";
	    Format.printf "@.@[<b>map f l' =@;@[<b 2>[@;";
	    pp Test_frame.i2s (Q.map (fun x -> x * 2) l');
	    Format.printf "@.";
	    Format.printf "@[<b 2>tolist l' =@;";
	    Test_frame.printList Test_frame.i2s (Q.tolist l');
	    Format.printf "@.";
	    exit 0
	end
  end

let _ = main ()
