(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question09 - test        *)

module Q = Question09

let is_empty s =
  if s#is_empty then "empty" else "not empty"

let rec push q s =
  try
    let n = q#getN in
      s#push n;
      Format.printf "@,OK pushed %d" n;
      push q s
  with
      Q.Stack_full -> Format.printf "@,OK stack full."

let rec pop s =
  try
    let n = s#pop in
      Format.printf "@,OK pop %d" n;
      pop s
  with
      Q.Stack_empty -> Format.printf "@,OK stack empty."

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 9 100 in
      q#beginParse;
      q#init;
      let size = q#getSize in
      let s = new Q.stack size 0 in
	Format.printf "Test de is_empty: %s@." (is_empty s);
	Format.printf "Test de size: %d@." s#size;
	Format.printf "@[<v 2>Test de push:";
	push q s;
	Format.printf "@]@.";
	Format.printf "Test de is_empty: %s@." (is_empty s);
	Format.printf "Test de size: %d@." s#size;
	Format.printf "Test de top: %d@." s#top;
	Format.printf "@[<v 2>Test de pop:";
	pop s;
	Format.printf "@]@.";
	Format.printf "Test de is_empty: %s@." (is_empty s);
	Format.printf "Test de size: %d@." s#size;
	exit 0
  end

let _ = main ()
