(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question10 - test        *)

module Q = Question10

module StrQ = Q.PriorityQueue(String)

let is_empty sq =
  if StrQ.is_empty sq then "empty" else "not empty"

let push q sq =
  for i = 1 to q#getSize do
    let s = q#makeString in
      StrQ.push s sq;
      Format.printf "@,OK pushed %s" s;
  done

let rec pop sq =
  try
    let s = StrQ.pop sq in
      Format.printf "@,OK poped %s" s;
      pop sq
  with
      Q.Queue_empty ->
	Format.printf "@,OK queue is empty."

let main () =
  begin
    let q = new Test_frame.qSizeString 10 3 in
      q#beginParse;
      q#init;
      let sq = StrQ.empty () in
	Format.printf "Test de is_empty: %s@." (is_empty sq);
	Format.printf "Test de size: %d@." (StrQ.size sq);
	Format.printf "@[<v 2>Test de push:";
	push q sq;
	Format.printf "@]@.";
	Format.printf "Test de is_empty: %s@." (is_empty sq);
	Format.printf "Test de size: %d@." (StrQ.size sq);
	Format.printf "@[<v 2>Test de pop:";
	pop sq;
	Format.printf "@]@.";
	Format.printf "Test de is_empty: %s@." (is_empty sq);
	Format.printf "Test de size: %d@." (StrQ.size sq);
	exit 0;
  end

let _ = main ()
